{% extends 'base.html.twig' %}

{% form_theme main_form _self %}

{% block _device_ips_entry_widget %}
    <tr class="ipRow" data-pool-id="{% if value and value.mikrotikPool %}{{ value.mikrotikPool.id }}{% endif %}">
        <td class="ipRowPoolName">{% if value and value.mikrotikPool %}{{ value.mikrotikPool.nome }} ({{ value.mikrotikPool.dottedIpStart }} - {{ value.mikrotikPool.dottedIpEnd }}){% endif %}</td>
        <td>{{ form_widget(form.ip) }}</td>
        <td>
            {{ form_widget(form.mikrotikPool) }}
            <a class="deleteBt btn btn-danger" onclick="deleteIpRow(this)">Elimina</a>
        </td>
    </tr>

    {% if not form.ip.vars.valid %}
    <tr>
        <td colspan="3">{{ form_errors(form.ip) }}</td>
    </tr>
    {% endif %}

{% endblock %}

{% block body %}
<main class='main-content bgc-grey-100'>
    <div id='mainContent'>
        <h1>{{ isEditing ? 'Modifica' : 'Creazione' }} dispositivo</h1>
            {{ form_start(main_form) }}
            {{ form_errors(main_form, { 'global_errors': true }) }}
            {{ form_row(main_form.device) }}
            {{ form_row(main_form.mac) }}
            {{ form_row(main_form.mikrotikList) }}

            {{ form_label(main_form.ips) }}
            <table id="ipList" data-prototype="{{ form_widget(main_form.ips.vars.prototype)|e }}">
                {% for ip in main_form.ips %}
                    {{ form_widget(ip) }}
                {% endfor %}
            </table>
            {% do main_form.ips.setRendered %}

            <div id="ipAddCont" class="d-flex mb-3">
                <select name="ipAddMikrotikPool" id="ipAddMikrotikPool" class="form-select w-auto me-1">
                    {% for mikrotikPool in mikrotikPoolList %}
                        <option value="{{ mikrotikPool.id }}">{{ mikrotikPool.nome }} ({{ mikrotikPool.dottedIpStart }} - {{ mikrotikPool.dottedIpEnd }})</option>
                    {% endfor %}
                </select>
                <a class="btn btn-secondary" id="ipAddMikrotikPoolBtn">Aggiungi</a>
            </div>

            {% if is_granted('ROLE_ADMIN') %}
                {{ form_row(main_form.bypassHotspot) }}
                {{ form_row(main_form.active) }}
            {% else %}
                {% do main_form.bypassHotspot.setRendered() %}
                {% do main_form.active.setRendered() %}
            {% endif %}

            {{ form_rest(main_form) }}

            <div class="row sendBtnArea mt-3">
                <div class="col-lg-4 mb-2 d-grid gap-2 d-lg-flex align-items-center">
                    <button type="submit" class="btn btn-success">Salva modifiche dispositivo</button>
                </div>
                <div class="col-lg-4 mb-2 d-grid gap-2 d-lg-flex align-items-center justify-content-lg-center">
                    <a href="{{ path('device', redirect_qs) }}" class="btn btn-info">
                        Ritorna alla lista
                    </a>
                </div>
                <div class="col-lg-4 mb-2 d-grid gap-2 d-lg-flex align-items-center justify-content-lg-end">
                    {% if is_granted('ROLE_ADMIN') and isEditing %}
                    <a href="{{ path('device_delete', { 'id': entity.id }) }}" class="btn btn-danger" onclick="return confirm('Sei sicuro di voler eliminare questo elemento?')">
                        Rimuovi l'accesso per questo dispositivo</a>
                    {% endif %}
                </div>
            </div>
        </form>
    </div>
</main>

{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script type="text/javascript">
        function deleteIpRow(el) {
            var $ipRow = $(el).parent().parent();
            $ipRow.remove();
        }

        $(document).ready(function() {
            var $poolSelect = $('#ipAddMikrotikPool');
            var $ipList = $("#ipList");
            var $ipAddMikrotikPoolBtn = $('#ipAddMikrotikPoolBtn');
            var poolLoading = false;

            $ipList.data('counter', $ipList.find(".ipRow").length);


            $ipAddMikrotikPoolBtn.click(function () {
                if(poolLoading)
                    return;

                var selectedPoolId = $poolSelect.val();
                var ipListRows = $ipList.find(".ipRow").toArray();

                if(selectedPoolId === null || selectedPoolId === "") {
                    alert("È necessario selezionare un pool di ip");
                    return;
                }

                for(var i in ipListRows) {
                    if ($(ipListRows[i]).data('pool-id') == selectedPoolId) {
                        alert("È già presente un indirizzo per il pool in questione");
                        return;
                    }
                }

                $.get("{{ path('mikrotik_pool_check_free_ip', {'id': "%id"}) }}".replace("%25id", selectedPoolId), function (data) {
                    var ip = "";
                    if (data.error !== undefined) {
                        alert('Si è verificato un errore: ' + data.error);
                    } else if (data.ip !== undefined || data.ip != "") {
                        ip = data.ip;
                    }

                    var counter =  $ipList.data('counter');
                    var baseName = "device_ips_"+counter;
                    var $newRow = $($ipList.data('prototype').replace(/__name__/g, counter));
                    $newRow.data('pool-id', selectedPoolId);
                    $newRow.children('.ipRowPoolName').append($poolSelect.children("option:selected").text());
                    $newRow.find("#"+baseName+"_ip").val(ip);
                    $newRow.find("#"+baseName+"_mikrotikPool").val(selectedPoolId);

                    $ipList.append($newRow);
                    $ipList.data('counter', counter + 1);
                    $ipAddMikrotikPoolBtn.text("Aggiungi");
                    poolLoading = false;
                }, 'json').fail(function() {
                    $ipAddMikrotikPoolBtn.text("Aggiungi");
                    poolLoading = false;
                });

                $ipAddMikrotikPoolBtn.text("Caricamento...");
                poolLoading = true;
            })

        });
    </script>


{% endblock %}
